{% extends "crud.html" %}


{% block sub_head %}
    {% assets
        filters="cssrewrite, cssmin",
        output="compressed/datepicker.css",
        "css/plugins/bootstrap-datepicker.min.css"
    %}
        {{ mg.async_css(ASSET_URL) }}
    {% endassets %}
    {% assets
        filters="rjsmin",
        output="compressed/datepicker.js",
        "js/plugins/bootstrap-datepicker.min.js"
    %}
        {{ mg.js(ASSET_URL) }}
    {% endassets %}
    <style>
        .gray-bg {
            background-color: #f5f5f5
        }
        [data-product-toggle="delete"] {
            margin-top: 27px!important;
        }
    </style>
{% endblock %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block datatable_filters %}
    <div class="col-12 offset-md-5 col-md-3">
        <div class="form-group">
            <select class="form-control" data-datatable-filter="3">
                <option value="">All Statuses</option>
                <option value="0">Draft/Stocks Pending</option>
                <option value="1">For Payment (Reserved)</option>
                <option value="2">For Delivery (Paid)</option>
                <option value="3">In Transit</option>
                <option value="4">Completed</option>
                <option value="-1">Void</option>
            </select>
        </div>
    </div>
{% endblock %}


{% block add_form %}
<div class="row">
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "client"|normalize|title }}*</label>
                    <select name="client" class="form-control" data-ajax-select-target="/api/v1/clients/all?fields=name,business_type" data-ajax-select-value="_id" data-ajax-select-label="name,business_type" required placeholder="-- Select Client --">
                        <option value="">-- Select Client --</option>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "outgoing_delivery_no"|normalize|title }}*</label>
                    <input type="text" name="outgoing_delivery_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-12" data-products-container>
        <h5>Finished Goods</h5>
        <div class="row">
            <div class="col-12 col-md-3">
                <a class="btn btn-warning btn-sm btn-block" href="javascript:;" data-product-toggle="add"> <i class="fa fa-plus"></i> Add Product</a>
            </div>
        </div>
    </div>
</div>
{% endblock %}


{% block empty_spiel %}
    Add Outgoing Deliveries, details include
    <br />
    breakdown of goods to be delivered, client info, etc.
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'outgoing_delivery_no',
        searchable: true,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                return '<a href="javascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> #{0}</a>'.format(data);
            }
        }
    },
    {
        data: 'client',
        searchable: false,
        orderable: true,
        render: function(data) {
            return data.name;
        }
    },
    {
        data: 'date_created',
        className: 'd-none d-sm-none d-md-table-cell',
        searchable: false,
        orderable: true
    },
    {
        data: 'status',
        searchable: false,
        orderable: true,
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                let spiels = ['Draft', 'For Payment (Reserved)', 'For Delivery (Paid)', 'In Transit', 'Completed', 'Void'];
                return '<span>{0} <a href="#"><i class="fa fa-fw fa-question-circle"></i></a></span>'.format(spiels[data]);
            }
        }
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            if (row.status === 0 || row.status === 1) {
                {% if session.user.access_levels.permissions.get(request.mod, {}).get('delete', False) %}
                return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i><span class="d-none d-sm-none d-md-inline"> Delete</span></a>'.format(data);
                {% else %}
                return '';
                {% endif %}
            }
            else {
                return '';
            }
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    function cycleBackground(bg) {
        $rows = $('.active[data-crud] [data-products-container] [data-form-dynamic]');
        $rows.removeClass(bg);
        $.each($rows, function(i, v) {
            if (i % 2 == 0) {
                $(v).addClass(bg)
            }
        });
    }

    $dom.body.on('click', '[data-product-toggle="add"]', function() {
        $('.active[data-crud] [data-products-container]').find('.row:last').after(`
            <div class="row" data-form-dynamic>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Product Code*</label>
                        <select name="products-product_code" class="form-control" data-ajax-select-target="/api/v1/finished_goods/all?fields=product_code,description" data-ajax-select-value="_id" data-ajax-select-label="product_code,description" required placeholder="-- Select Product Code --">
                            <option value="">-- Select Product Code --</option>
                        </select>
                    </div>
                </div>
                <div class="col-6 col-md-3">
                    <div class="form-group">
                        <label>Quantity*</label>
                        <input type="number" name="products-quantity" class="form-control" min="0" step="0.0001" required />
                    </div>
                </div>
                <div class="col-6 col-md-3">
                    <div class="form-group">
                        <label>Price per Unit</label>
                        <input type="number" name="products-price_per_unit" class="form-control" min="0.01" step="0.01" />
                    </div>
                </div>
                <div class="col-6 col-md-2">
                    <a href="javascript:;" class="mt-3 btn btn-danger btn-sm btn-block" data-product-toggle="delete"><i class="fa fa-fw fa-trash"></i> Delete</a>
                </div>
            </div>
        `);
        $('.active[data-crud] [data-products-container] .row:last [data-ajax-select-target]').ajaxDropdown();
        cycleBackground('gray-bg');
    });

    $dom.body.on('click', '[data-product-toggle="delete"]', function() {
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Delete Product',
            text: 'Unsaved information will be removed',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $self.closest('[data-form-dynamic]').remove();
                cycleBackground('gray-bg');
            }
        });
    });
{# </script> #}
{% endblock %}
